-- This file is for use with Gideros Framework
--
-- This file is automatically generated with PhysicsEdtior (http://physicseditor.de). Do not edit
--
-- Usage example:
--			require "box2d"
--			local world = b2.World.new(0, 9.8)			
--			local body = world:createBody{type = b2.DYNAMIC_BODY}
--			local scaleFactor = 1.0
--			local physics = (loadfile "PhysicsData.lua")().physicsData(scaleFactor)			
--			physics:addFixture(body, objectname)
--

local M = {}

function M.physicsData(scale)
	local physics = {  data =
	{ {% for body in bodies %}
		{% if not forloop.first %}, {% endif %}
		["{{body.name}}"] = { 
		    		anchorPoint = { {{body.anchorPointRel.x|floatformat:3}}, {{body.anchorPointRel.y|floatformat:3}}}, fixtures = {
                    {% for fixture in body.fixtures %}
                    {% if not forloop.first %} ,{% endif %}
                    {% if fixture.isCircle %}
                    {
                    pe_fixture_id = "{{fixture.pe_fixture_id}}", density = {{fixture.density}}, friction = {{fixture.friction}}, restitution = {{fixture.bounce}}, {% if fixture.isSensor %}sensor=true, {% else %}sensor=false, {% endif %}
                    filter = { categoryBits = {{fixture.filter_categoryBits}}, maskBits = {{fixture.filter_maskBits}}, groupIndex = {{fixture.filter_groupIndex}} },
                    radius = {{fixture.radius|floatformat:3}},
                    center = { x={{fixture.center.x|floatformat:3}}, y={{fixture.center.y|floatformat:3}}}
                    }
                    {% else %}
                    {% for polygon in fixture.polygons %}{% if not forloop.first %} ,{% endif %}
                    {
                    pe_fixture_id = "{{fixture.pe_fixture_id}}", density = {{fixture.density}}, friction = {{fixture.friction}}, restitution = {{fixture.bounce}}, {% if fixture.isSensor %}sensor=true, {% else %}sensor=false, {% endif %}
                    filter = { categoryBits = {{fixture.filter_categoryBits}}, maskBits = {{fixture.filter_maskBits}}, groupIndex = {{fixture.filter_groupIndex}} },
                    shape = { {% for point in polygon %} {% if not forloop.first %}, {% endif %} {{point.x}}, {{point.y}} {% endfor %} }
                    }
                    {% endfor %}
                    {% endif %}
                    {% endfor %}
			}
		}
		{% endfor %}
	} }

        -- apply scale factor
        local s = scale or 1.0
        for bi,body in pairs(physics.data) do
                for fi,fixture in ipairs(body) do
                    if(fixture.shape) then
                        for ci,coordinate in ipairs(fixture.shape) do
                            fixture.shape[ci] = s * coordinate
                        end
                    else
                        fixture.radius = s * fixture.radius
                    end
                end
        end
	
	-- add Fixtures to body
	function physics:addFixture(body, name)
		for fi,fixture in pairs(physics.data[name].fixtures) do
			local shape
			if(fixture.shape) then
				shape = b2.PolygonShape.new()
				shape:set(unpack(fixture.shape))			
			else
				shape = b2.CircleShape.new(fixture.center.x, fixture.center.y, fixture.radius)
			end
			body:createFixture{shape = shape, density = fixture.density, restitution = fixture.restitution, friction = fixture.friction, filter = fixture.filter, isSensor=fixture.sensor}
		end
	end

	-- get anchorpoint to specific body
	function physics:getAnchorPoint(name)
		return unpack(physics.data[name].anchorPoint)		
	end
	
	return physics;
end

return M

