-- This file is for use with Corona(R) SDK
--
-- This file is automatically generated with PhysicsEdtior (http://physicseditor.de). Do not edit
--
-- Usage example:
--			local scaleFactor = 1.0
--			local physicsData = (require "shapedefs").physicsData(scaleFactor)
--			local shape = display.newImage("objectname.png")
--			physics.addBody( shape, physicsData:get("objectname") )
--

-- copy needed functions to local scope
local unpack = unpack
local pairs = pairs
local ipairs = ipairs

module(...)

function physicsData(scale)
	local physics = { data =
	{ {% for body in bodies %}
		{% if not forloop.first %}, {% endif %}
		["{{body.name}}"] = {
			{% for fixture in body.fixtures %}{% if not forloop.first %} ,{% endif %}{% for polygon in fixture.polygons %}{% if not forloop.first %} ,{% endif %}
				{
					density = {{fixture.density}}, friction = {{fixture.friction}}, bounce = {{fixture.bounce}}, {% if fixture.isSensor %}isSensor=true, {% endif %}
					filter = { categoryBits = {{fixture.filter_categoryBits}}, maskBits = {{fixture.filter_maskBits}} },
					shape = { {% for point in polygon %} {% if not forloop.first %}, {% endif %} {{point.x}}, {{point.y}} {% endfor %} }
				} {% endfor %} {% endfor %}
		}
		{% endfor %}
	} }

	-- apply scale factor
	local s = scale or 1.0
	for bi,body in pairs(physics.data) do
		for fi,fixture in ipairs(body) do
			for ci,coordinate in ipairs(fixture.shape) do
				fixture.shape[ci] = s * coordinate
			end
		end
	end
	
	function physics:get(name)
		return unpack(self.data[name])
	end
	
	return physics;
end


